"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.detectChanges = exports.snapshot = void 0;
const sn = require("./snapshots");
const report_1 = require("./report");
const core_1 = require("./core");
const core_2 = require("@paperclip-ui/core");
const utils_1 = require("./utils");
const snapshot = (options) => __awaiter(void 0, void 0, void 0, function* () {
    const provider = yield (0, core_1.start)(options.cwd);
    yield sn.snapshot(provider)(options.force);
    yield provider.close();
});
exports.snapshot = snapshot;
const detectChanges = (options) => __awaiter(void 0, void 0, void 0, function* () {
    const provider = yield (0, core_1.start)(options.cwd);
    const run = (open) => __awaiter(void 0, void 0, void 0, function* () {
        yield detectChanges2(Object.assign(Object.assign({}, options), { open }), provider);
        if (options.watch) {
            (0, utils_1.logInfo)(`Waiting for file changes...`);
            const watcher = new core_2.PaperclipResourceWatcher(".", options.cwd);
            watcher.onChange(() => {
                watcher.dispose();
                run(false);
            });
        }
    });
    yield run(options.open);
    if (!options.watch) {
        yield provider.close();
    }
});
exports.detectChanges = detectChanges;
const detectChanges2 = (options, provider) => __awaiter(void 0, void 0, void 0, function* () {
    const result = yield sn.detectChanges(provider)(options.branch);
    yield (0, report_1.writeReport)(Object.assign(Object.assign({}, result), { gitDir: provider.gitDir, cwd: options.cwd, open: options.open }), options);
});
